/*
  $Id: HexeVote.java,v 1.2 2003/10/08 10:24:22 taku-ku Exp $;
*/

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import java.net.*;
import java.applet.*;
import java.applet.AudioClip;

public class HexeVote extends Applet implements MouseListener {

    Image image_pressed;
    Image image_released;
    Image current_image;
    AudioClip sound;
    Color color;
    int x, y;
    URL update_url;
    int num;
    int start;

    final int maxpress = 20;
    final int maxnum   = 999;

    private int getURLNumber (URL url)
    {
	try {
	    BufferedReader br = new BufferedReader (new InputStreamReader (url.openStream ()));
	    String tmp = br.readLine ();
	    return (new Integer (tmp)).intValue ();
	}

	catch (Exception e) {
	    return -1;
	}
    }

    public void init ()
    {
	try {

	    String tmp;

	    URL documentBase = getDocumentBase ();

	    image_released   = getImage (documentBase, getParameter ("image_released"));
	    image_pressed    = getImage (documentBase, getParameter ("image_pressed"));

	    tmp = getParameter ("init_url");
	    URL init_url     = (tmp == null ? null : new URL  (documentBase, tmp));

	    tmp = getParameter ("update_url");
	    update_url       = (tmp == null ? null : new URL  (documentBase, tmp));

	    tmp = getParameter ("sound");
	    sound = (tmp == null ? null : getAudioClip (documentBase, tmp));

	    tmp = getParameter ("fgcolor");
	    color = Color.decode (tmp == null ? "#ffff00" : tmp);  // yellow

	    tmp = getParameter ("bgcolor");
	    Color bgcolor = Color.decode (tmp == null ? "#000000" : tmp); // black

	    tmp = getParameter ("x");
	    x = (tmp == null ? 50 : (new Integer (tmp)).intValue ());

	    tmp = getParameter ("y");
	    y = (tmp == null ? 20 : (new Integer (tmp)).intValue ());

	    num = (init_url == null ? 0 : getURLNumber (init_url));
	    start = num;

	    current_image = image_released;
	    setBackground (bgcolor);
	    addMouseListener (this);
	}

	catch (Exception e) {
	    System.exit (0);
	}
    }

    public void destroy() 
    {
        removeMouseListener(this);
    }

    public void mousePressed(MouseEvent e) 
    {
	if (sound != null) sound.play ();
	current_image = image_pressed;
	repaint ();
    }

    public void mouseReleased (MouseEvent e) 
    {
	if ((num - start) <= maxpress && num < maxnum)
	    num = (update_url == null ? num + 1:  getURLNumber (update_url));

	current_image = image_released;
	repaint ();
    }

    public void mouseClicked  (MouseEvent e) {}
    public void mouseEntered  (MouseEvent e) {}
    public void mouseExited   (MouseEvent e) {}

    public void paint (Graphics g) 
    {
	g.setColor (color);
	g.drawString ((new Integer (num)).toString (), x, y);
	g.drawImage (current_image, 0, 0, this);
    } 
}
